program shengmingyouxi;
uses windows,display;

var bufflen:longword;
var sc,ss:pbitmap;
var bmi:BITMAPINFO;
var buffb:Pointer;
var w,h,z:longword;
var cb,cg,cr:byte;

procedure InitBMI();
begin
with bmi.bmiHeader do
  begin
  biSize:=sizeof(bmi.bmiHeader);
  biWidth:=GetWidth;
  biHeight:=GetHeight;
  biPlanes:=1;
  biBitCount:=24;
  biCompression:=BI_RGB;
  end;
end;

procedure InitScr();
begin
w:=GetWidth;
h:=GetHeight;
sc:=allocmem(BUFFSIZE);
sc^.Handle:=GetDesktopWindow();
sc^.DC:=GetDC(sc^.Handle);
sc^.Width:=w;
sc^.Height:=h;
sc^.Color:=0;
//_dc:=sc^.dc;
//_hw:=sc^.handle;
ss:=CreateBMP(sc);
end;

procedure InitBuffB();
begin
bufflen:=w*h*4;
buffb:=AllocMem(bufflen);
end;

procedure FreeBuffB();
begin
FreeMem(buffb);
end;

procedure GetBuffB();
begin
DrawBMP(sc,ss);
GetDIBits(ss^.dc,ss^.Handle,0,ss^.height,buffb,bmi,DIB_RGB_COLORS);
end;

procedure SetBuffB();
begin
SetDIBits(ss^.dc,ss^.Handle,0,ss^.height,buffb,bmi,DIB_RGB_COLORS);
DrawBMP(ss,0,0,w,h);
end;

function GetBuff(x,y:longword):longword;
begin
z:=((w*3)+3)div 4*4*(h-(1+y))+x*3;
cb:=pbyte(buffb+z)^;
cg:=pbyte(buffb+z+1)^;
cr:=pbyte(buffb+z+2)^;
GetBuff:=cb shl 16 or cg shl 8 or cr;
end;

procedure SetBuff(x,y,c:longword);
begin
z:=((w*3)+3)div 4*4*(h-(1+y))+x*3;
cb:=byte(c and $FF);c:=c shr 8;
cg:=byte(c and $FF);c:=c shr 8;
cr:=byte(c and $FF);
pbyte(buffb+z)^:=cb;
pbyte(buffb+z+1)^:=cg;
pbyte(buffb+z+2)^:=cr;
end;

const
   cs=blue;
   cc=red;
   cm=yellow;
   cn=green;
   grolim=1000;
   stepdes=1;
   samedes=20;
   rules:array[0..8]of integer=(0,0,2,1,0,0,0,0,0);
   dc:array[1..27]of longword=(cm,cm,cm,cm,cm,cm,cm,cm,cc,cc,cs,cs,cs,cs,cs,cs,cc,cc,cc,cc,cc,cc,cc,cc,cc,cc,cs);
   d:array[1..27,1..4,1..4]of integer=(
   ((0,2,1,2),(1,0,1,2),(0,2,1,2),(2,2,2,2)),
   ((1,2,0,2),(1,0,1,2),(1,2,0,2),(2,2,2,2)),
   ((1,1,1,2),(2,0,2,2),(0,1,0,2),(2,2,2,2)),
   ((0,1,0,2),(2,0,2,2),(1,1,1,2),(2,2,2,2)),
   ((0,1,0,2),(2,1,2,2),(1,0,1,2),(2,2,2,2)),
   ((1,0,1,2),(2,1,2,2),(0,1,0,2),(2,2,2,2)),
   ((0,2,1,2),(1,1,0,2),(0,2,1,2),(2,2,2,2)),
   ((1,2,0,2),(0,1,1,2),(1,2,0,2),(2,2,2,2)),
   ((0,0,0,2),(1,1,1,2),(0,0,0,2),(2,2,2,2)),
   ((0,1,0,2),(0,1,0,2),(0,1,0,2),(2,2,2,2)),
   ((2,1,2,2),(1,0,1,2),(2,1,2,2),(2,2,2,2)),
   ((2,1,2,2),(1,0,1,2),(1,0,1,2),(2,1,2,2)),
   ((2,1,1,2),(1,0,0,1),(2,1,1,2),(2,2,2,2)),
   ((2,1,1,2),(1,0,0,1),(1,0,0,1),(2,1,1,2)),
   ((2,1,2,2),(1,0,2,2),(2,2,0,1),(2,2,1,2)),
   ((2,2,1,2),(2,2,0,1),(1,0,2,2),(2,1,2,2)),
   ((2,2,2,2),(2,1,1,1),(1,1,1,2),(2,2,2,2)),
   ((2,2,2,2),(1,1,1,2),(2,1,1,1),(2,2,2,2)),
   ((2,2,1,2),(2,1,1,2),(2,1,1,2),(2,1,2,2)),
   ((2,1,2,2),(2,1,1,2),(2,1,1,2),(2,2,1,2)),
   ((2,0,1,2),(1,0,0,1),(1,0,0,1),(2,1,0,2)),
   ((2,1,0,2),(1,0,0,1),(1,0,0,1),(2,0,1,2)),
   ((2,1,1,2),(0,0,0,1),(1,0,0,0),(2,1,1,2)),
   ((2,1,1,2),(1,0,0,0),(0,0,0,1),(2,1,1,2)),
   ((1,1,2,2),(1,0,2,2),(2,2,0,1),(2,2,1,1)),
   ((2,2,1,1),(2,2,0,1),(1,0,2,2),(1,1,2,2)),
   ((2,0,0,2),(0,1,1,0),(0,1,1,0),(2,0,0,2))
   );

var
   gd,gm:integer;
   ch:char;
   st:string;
   gro,outstep,textstep,ranstep,addrand,width,long:integer;
   edge,rand,gun:boolean;
   a,b:array[-4..1000+5,-4..1000+5]of boolean;
   c:array[-4..1000+5,-4..1000+5]of longword;

   sam:array[0..samedes+1] of longint;
   i,j,k,l,m,n,ni,step,sameboo,sameboo2:longint;
   same,clr:longint;
   str1,str2,str3:string;
   over,over2,life:boolean;
   x,y:integer;
   rulesboo:array[0..8]of boolean;

procedure init2;
const g:array[1..11,1..40]of shortint=(
(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0),
(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0),
(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0),
(0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0),
(0,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(0,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,1,0,1,1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0),
(0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0),
(0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),
(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
);
begin
for i:=1 to 11 do
  for j:=1 to 40 do
    if g[i,j]=1 then a[j,i]:=true;
end;

procedure init;
var ran:integer;
begin
randomize;
if rand then
  begin
  for i:=1 to gro do
    for j:=1 to gro do
      begin
      ran:=random(ranstep);
      if ran=0 then a[i,j]:=true;
      end;
   end
else
  for i:=1 to width do
    for j:=1 to long do
      a[i,j]:=true;
end;

label 1;

begin
createwin(800,600);
InitBMI();
InitScr();
InitBuffB();

gro:=600;
outstep:=2;
textstep:=2;
ranstep:=10;
addrand:=0;
width:=10;
long:=10;
edge:=true;
rand:=true;
gun:=false;

x:=gro;
y:=gro;
if gun then init2 else init;
over:=false;
same:=1;
step:=0;
while (not over) or (not over2) do
  begin
  step:=step+1;
  over2:=over;
  if ((sameboo<-2) and (sameboo=sameboo2)) then over:=true;
  if ((step mod outstep)=0) or (over) then
    begin
    for i:=-4 to (gro+5) do
      for j:=-4 to (gro+5) do
        if a[i,j] then c[i,j]:=cn else c[i,j]:=black;
  {
    for k:=1 to 27 do
      for i:=1 to gro do
         for j:=1 to gro do
           begin
//           life:=true;
           for l:=1 to 4 do
             for m:=1 to 4 do
               begin
               if d[k,l,m]=1 then
                 if not a[i+l-1,j+m-1] then
goto 1;//                   begin life:=false;break;end;
               if d[k,l,m]=0 then
                 if a[i+l-1,j+m-1] then
goto 1;//                   begin life:=false;break;end;
               end;
//           if life then
             for l:=1 to 4 do
               for m:=1 to 4 do
                 if c[i+l-1,j+m-1]<>black then
                   c[i+l-1,j+m-1]:=dc[k];
           1:
           end;
   }
    for i:=1 to gro do
      for j:=1 to gro do
//        if getbuff(i-1,j-1)<>c[i,j] then
          setbuff(i-1,j-1,c[i,j]);
//Move(c,buffb^,bufflen);
Bar(0,0,gro,gro,black);
SetBuffB();
    end;

  if ((step mod textstep)=0) or (over) then
    begin
    for k:=10 downto 1 do
      begin
      case k of
       10:l:=gro;
        9:l:=outstep;
        8:l:=textstep;
        7:if edge then str1:='true' else str1:='false';
        6:if rand then
            begin
            str(ranstep,str2);
            str(addrand,str3);
            str1:='true/'+str2+'/'+str3;
            end
          else
            begin
            str(width,str2);
            str(long,str3);
            str1:='false/'+str2+'/'+str3;
            end;
        5:begin
          str1:='';
          for m:=1 to 8 do
            begin
            str(rules[m],str2);
            str1:=str1+str2;
            end;
          end;
        4:l:=step;
        3:l:=same;
        2:begin
          l:=(same*10000) div (gro*gro);
          str((l div 100),str2);
          str((l mod 100),str3);
          str1:=str2+'.'+str3+'% ';
          end;
        1:l:=sameboo;
        end;
      if (k>7) or (k<5) and (k<>2) then
        str(l,str1);
      case k of
       10:str1:='size   :'+str1;
        9:str1:='outstep:'+str1;
        8:str1:='txtstep:'+str1;
        7:str1:='edge   :'+str1;
        6:str1:='random :'+str1;
        5:str1:='rules  :'+str1;
        4:str1:='step   :'+str1;
        3:str1:='life   :'+str1;
        2:str1:='lifepro:'+str1;
        1:str1:='end    :'+str1;
        end;
      if (gro<200) then
        drawtextxy(str1,integer(i+10),integer(200-k*20),black,white)
      else
        drawtextxy(str1,integer(i+10),integer(j-k*20),black,white);
    end;
  end;

  if edge then
    begin
    for j:=1 to 5 do for i:=-4 to gro+5 do a[i,j-5]:=a[i,gro+j-6];
    for j:=1 to 5 do for i:=-4 to gro+5 do a[i,gro+j-1]:=a[i,j];
    for j:=1 to 5 do for i:=-4 to gro+5 do a[j-5,i]:=a[gro+j-6,i];
    for j:=1 to 5 do for i:=-4 to gro+5 do a[gro+j-1,i]:=a[j,i];
    end;
  for i:=1 to gro do
    for j:=1 to gro do
      begin
        n:=0;
        if a[i-1,j-1]=true then n:=n+1;
        if a[i-1,j]=true then n:=n+1;
        if a[i-1,j+1]=true then n:=n+1;
        if a[i,j-1]=true then n:=n+1;
        if a[i,j+1]=true then n:=n+1;
        if a[i+1,j-1]=true then n:=n+1;
        if a[i+1,j]=true then n:=n+1;
        if a[i+1,j+1]=true then n:=n+1;
        for ni:=0 to 8 do
          case rules[ni] of
            0:rulesboo[ni]:=false;
            1:rulesboo[ni]:=true;
            2:rulesboo[ni]:=a[i,j];
          end;
        b[i,j]:=rulesboo[n];
      end;
  same:=0;
  for i:=samedes downto 1 do
    sam[i+1]:=sam[i];
  for i:=1 to gro do
    for j:=1 to gro do
      if a[i,j]=true then same:=same+1;
  sam[1]:=same;
  sameboo2:=sameboo;
  sameboo:=0;
  for i:=2 to samedes do
    if sam[1]=sam[i] then sameboo:=sameboo-1;
  for i:=1 to gro do
    for j:=1 to gro do
      a[i,j]:=b[i,j];
  if over2 then
    begin
    for n:=1 to addrand do
      begin
      i:=random(gro-1)+1;
      j:=random(gro-1)+1;
      a[i,j]:=true;
      end;
    step:=step-2;
    over:=false;
    end;
  while IsNextmsg do ;
  freshwin();
  delay(1);
  end;
end.
